<?/*
   * This source is made by flupke - flupke@wanadoo.fr
   *
   * This program is modifiable/redistributable under the terms of the GNU
   * General Public License.
   *
   * You should have recieved a copy of the GNU General Public License along
   * with this program; see the file COPYING. If not, write to the Free Software
   * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 0211-1307, USA.
   *
   */?>
<?php

///////////////////////////////////////////////////////////////////////////////
// usefull functions


///////////////////////////////////////////////////////////////////////////////
// ripped from CK1 in php.net columns
//
// Call the function like this:
// $array = qsort_multiarray(array $array, int $n, string $order, int $left,
// int $right); $array is the array which should be sorted, int $n is the index
// of the sort
//
// criterium, $order is "ASC" or "DESC" for ascending
// sorting or descending sorting, $left is the left index and $right is the
// right index.
// The default sort is ASC. $left and $right are optional.

function qsort_multiarray($array, $num = 0, $order = "ASC", $left = 0, $right = -1) {
/*  if($right == -1) {
    $right = count($array) - 1;
  }
  
  $links = $left;
  $rechts = $right;
  $mitte = $array[($left + $right) / 2][$num];

  if($rechts > $links) {
    do {
      if ($order == "ASC") {
        while($array[$links][$num]<$mitte) $links++;
        while($array[$rechts][$num]>$mitte) $rechts--;
      } else {
        while($array[$links][$num]>$mitte) $links++;
        while($array[$rechts][$num]<$mitte) $rechts--;
      }
     
      if($links <= $rechts) {
        $tmp = $array[$links];
        $array[$links++] = $array[$rechts];
        $array[$rechts--] = $tmp;
      }

    } while($links <= $rechts);

    $array = qsort_multiarray($array,$num,$order,$left, $rechts);
    $array = qsort_multiarray($array,$num,$order,$links,$right);
  }
 
  return $array;*/

  die("this function is buggy!");
}

///////////////////////////////////////////////////////////////////////////////
// checks if a domain is valid
function isValidDomain($domain) {
  // TODO : check if the passed string is an IP, return true if so
  
  // basic check : a domain must be 2 space-free strings separated by a '.'
  if (strstr($domain, " ") != false)
    return false;
  
  $pos = strpos($domain, ".");
  if (!is_integer($pos)) {
    // '.' not found
    return false;
  }
  
  if ($pos == 0) {
    // no domain name
    return false;
  }
  
  $len = strlen($domain);
  if ($pos == $len - 1) {
    // no domain suffix
    return false;
  }
  
  // TODO: do a DNS search on domain (optional)
  
  return true;
}

///////////////////////////////////////////////////////////////////////////////
// checks if a mail address is valid
function isValidEmail($email) {
  // search for '@'
  $pos = strpos($email, "@");
  
  if (!is_integer($pos)) {
    // no '@'
    return false;
  }
  
  if ($pos == 0) {
    // no name
    return false;
  }

  $len = strlen($email);
  if ($pos == $len - 1) {
    // no domain
    return false;
  }

  // verify that domain is valid
  return isValidDomain(substr($email, $pos + 1));
}

///////////////////////////////////////////////////////////////////////////////
// make a text input from a variable, variable is destroyed with the resulting
// string
function mkTextInput(&$var, $name, $size = 19, $inputParams = "") {
  $inputPrefix = "<input type=\"text\" align=\"right\" size=\"$size\" name=\"";
  
  if (is_array($var)) {
    for ($i = 0 ; $i < count($var) ; $i++) {
      $var[$i] = $inputPrefix . $name . "[" . strval($i) ."]\" value=\"$var[$i]\" $inputParams>";
    }
  } else {
    $var = $inputPrefix . "$name\" value=\"$var\" $inputParams>";
  }
}

/////////////////////////////////////////////////////////////////////////////
// parses a date, supposed to be in dd/MM/yyyy format ;
// returns a timestamp of the given day at 00:00
// returns -1 on parse or date format error

  // Epoch is January 1 1970 00:00:00 GMT

function myParseDate($str) {
  $elts = split("/", $str);
  
  if (sizeof($elts) != 3)
    return -1;

  $day = intval($elts[0]);
  $month = intval($elts[1]);
  $year = intval($elts[2]);
  
  if (($day < 1) || ($day > 31))
    return -1;
    
  if (($month < 1) || ($month > 12))
    return -1;

  if ($year < 1970)
    return -1;
  
  if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) {
    // bisextile year
    if (($month == 2) && ($day > 29))
      return -1;
  } else {
    // non-bisextile year
    if (($month == 2) && ($day > 28))
      return -1;
  }
  
  // make time
  $time = mktime(0, 0, 0, $month, $day, $year);
    
  return $time;
}


///////////////////////////////////////////////////////////////////////////////
// parses a date in full natural format :
// [dd/MM/]yyyy [hh[:mm[:ss]]]
function parseFullDate($str) {  
  $str = trim($str);
  
  $elts = split(" ", $str);

  if (count($elts) == 1) {
    // only a date
    if (($res = myParseDate($elts[0])) == -1) {
      // maybe a single year
      if (strlen($elts[0]) == 4) {
        return mktime(0, 0, 0, 1, 1, $elts[0]);
      } else {
        return -1;
      }
    } else {
      return $res;
    }        
  } else if (count($elts) == 2) {
    if (($res = myParseDate($elts[0])) == -1) {
      return -1;
    } else {
      // multipliers for parsing time part
      $secondsVal = array(3600, 60, 1);  
      // get time vars
      $time_elts = split(":", $elts[1]);
      for ($i = 0 ; $i < count($time_elts) ; $i++) {
        $res += intval($time_elts[$i]) * $secondsVal[$i];
      }
      return $res;
    }    
  } else {
    return -1;
  }
}



?>
